# importy se píší na začátek, aby člověk nemusel prohledávat celý program, jaké další knihovny se používají...
import turtle

#
# A) výpočet předpisu pro třetí generaci Dračí křivky
#

stará_generace = 'FX+FX+'

for i in range(1, 13):
    nová_generace = ''  # prázdný řetězec
    # výpočet nové generace
    for znak in stará_generace:
        match znak:
            case 'X':
                nová_generace += 'X+YF'
            case 'Y':
                nová_generace += 'FX-Y'
            case _:     # ostatní znaky zkopírujeme tak jak jsou
                nová_generace += znak
    # nová generace se stane starou a z ní vypočítáme ještě novější generaci
    stará_generace = nová_generace

#
# B) vykreslení třetí generace Kochova ostrova
#

#turtle.speed(0)
turtle.tracer(3)
turtle.teleport(0, 100)
turtle.left(90)

předpis = stará_generace

# zaveďmež si užitečné "konstanty" -- jiný zápis pomocí tzv. n-tic (vlevo od '=' dvojce, vpravo od '=' také dvojce)
# PS: Python pojem 'konstanta' nezná, ale při pojmenování pomocí samých velkých písmen všichni předstírají, že to konstanty jsou...
KROK, ÚHEL = 2, 90

turtle.title('Dračí křivka (3. generace)')
turtle.bgcolor('lightblue')
turtle.pensize(2)

zásobník_stavů_želvy = []   # list()

for znak in předpis:
    match znak:
        case 'F' | 'X' | 'Y':
            turtle.forward(KROK)
        case '-':
            turtle.right(ÚHEL)
        case '+':
            turtle.left(ÚHEL)
        case '[':
            zásobník_stavů_želvy.append(
                (turtle.position(), turtle.heading())   # dvojce (= jeden prvek)
            )
        case ']':
            poslední_stav_želvy = zásobník_stavů_želvy.pop(-1)
            pozice, úhel = poslední_stav_želvy  # dvojce = dvojce
            # při přesunu želva nekreslí
            turtle.penup()
            turtle.setposition(pozice)
            turtle.pendown()
            # při otáčení se nekreslí automaticky -- želva je pořád na stejném místě
            turtle.setheading(úhel)

turtle.mainloop()
